Bug 321128 - launchers icons are wide in the panel
Summary: launchers icons are wide in the panel
Status: RESOLVED FIXED
Alias: None
Product: plasma4
Classification: Unclassified
Component: widget-taskbar (show other bugs)
Version: 4.10.95
Platform: Compiled Sources Linux
: NOR major with 1 vote (vote)
Target Milestone: ---
Assignee: Plasma Bugs List
URL:
Keywords:
: 278910 302778 321334 (view as bug list)
Depends on:
Blocks:
 
Reported: 2013-06-13 20:00 UTC by Andrea Scarpino
Modified: 2013-11-28 23:13 UTC (History)
13 users (show)

See Also:
Latest Commit:
Version Fixed In:


Attachments
Screenshot of the regression (90.69 KB, image/png)
2013-06-13 20:01 UTC, Andrea Scarpino
Details
Another screenshot of the regression. (175.68 KB, image/png)
2013-06-22 19:09 UTC, Olivier van der Toorn
Details
small regression (16.68 KB, image/png)
2013-07-27 22:01 UTC, Hrvoje Senjan
Details
wrongly expanding plasmoids in bar 4.11.2 (81.48 KB, image/png)
2013-11-28 23:09 UTC, stakanov.s
Details
Detail of ghost pictures remaining "burned" on the screen. 4.11.2 (93.17 KB, image/png)
2013-11-28 23:13 UTC, stakanov.s
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Andrea Scarpino 2013-06-13 20:00:38 UTC
I just updated to 4.10.80 and the launchers icons in the Task Manager are wide and the text doesn't show properly.

Screenshot is attached.

Reproducible: Always

Actual Results:  
the launchers icons in the Task Manager are wide and the text doesn't show properly.

Expected Results:  
the launchers icons in the Task Manager are just "icons" and the text shows properly.

KDE 4.10.80
Ask for more.
Comment 1 Andrea Scarpino 2013-06-13 20:01:15 UTC
Created attachment 80503 [details]
Screenshot of the regression
Comment 2 Andrea Scarpino 2013-06-13 20:02:17 UTC
(In reply to comment #1)
> Created attachment 80503 [details]
> Screenshot of the regression

In this screenshot, Dolphin is a launcher, Chromium an inactive window and Konversation the active one.
Comment 3 Hrvoje Senjan 2013-06-13 20:32:41 UTC
"Known issue":
http://mail.kde.org/pipermail/plasma-devel/2013-June/025567.html
Comment 4 Aaron J. Seigo 2013-06-15 15:09:54 UTC
*** Bug 302778 has been marked as a duplicate of this bug. ***
Comment 5 Aaron J. Seigo 2013-06-15 19:35:26 UTC
*** Bug 278910 has been marked as a duplicate of this bug. ***
Comment 6 Hrvoje Senjan 2013-06-18 23:07:27 UTC
*** Bug 321334 has been marked as a duplicate of this bug. ***
Comment 7 Olivier van der Toorn 2013-06-22 19:07:51 UTC
I can confirm this bug on Kubuntu Raring (13.04) running KDE SC 4.10.80. In the screenshot I will attach, Konsole is an inactive launcher.
Comment 8 Olivier van der Toorn 2013-06-22 19:09:17 UTC
Created attachment 80717 [details]
Another screenshot of the regression.

Konsole is an inactive launcher. Chromium is active.
Comment 9 Thomas Pfeiffer 2013-06-28 18:07:02 UTC
This bug is still present in 4.10.90. Is there a fix in sight? The tasks Plasmoid should not be shipped with this regression, as it makes launchers pretty much useless.
Comment 10 rockonthemoonfm 2013-07-01 12:31:12 UTC
confirm 4.11 beta 2 taskbar bug: launchers show text.

there's also the problem of text being corrupted when panel height is _very_ small.

apart from the two bugs that must be fixed for a quality final release, panel should have a fixed minimum height much higher than what we have now. panel can be so much small that all widget we have are unusable/useless and do create ui bugs. can't give an absolute panel min pixel height, but it's certainly at least the double of actual one.

cheers
Comment 11 Eike Hein 2013-07-07 17:48:41 UTC
*** Bug 322072 has been marked as a duplicate of this bug. ***
Comment 12 Mark 2013-07-20 15:10:12 UTC
Working on this one: https://git.reviewboard.kde.org/r/111618/

The patch is already there, i only need a "Ship it" to push it and get this issue resolved.
Comment 13 Eike Hein 2013-07-27 17:15:19 UTC
Fixed properly in f21aaf0b37.
Comment 14 Hrvoje Senjan 2013-07-27 22:01:11 UTC
Created attachment 81394 [details]
small regression

(In reply to comment #13)
> Fixed properly in f21aaf0b37.
*Small* regression with this commit. With launchers, first opened task is double of it's regular size. Can't reproduce 100%
Comment 15 Eike Hein 2013-07-27 22:35:39 UTC
The layout approach is roughly as follows: The number of launcher items are converted to the number of logical layout "big tasks" they fill up, with rounding. All layout calculation is then done based on the combination of the number of non-launcher tasks and those logical launcher layout tasks. In a single-row configuration, the difference between the width of those logical layout tasks and the actual launcher items is divided equally among the non-launcher tasks; in a multi-row configuration the non-launcher task adjacent to the last launcher is instead made shorter or longer to otherwise maintain an orderly grid.

This is how the old applet used to screw up launchers and multi-row:

http://wstaw.org/m/2013/04/05/plasma-desktopz25948.png

(Notice how the task on the second row pushes the launchers on the first row aside.)

This is how the new applet does it:

http://wstaw.org/m/2013/07/28/plasma-desktopoe9837.png
http://wstaw.org/m/2013/07/28/plasma-desktopcm9837.png

(Notice how the KMail task has its size adjusted so the other tasks otherwise maintain an orderly grid.)

I played with numerous alternatives: Always rounding down, always rounding up, making a gap between the last launcher and the first non-launcher task instead of adjusting the task size, etc., but this felt best overall.

And the single row case:

http://wstaw.org/m/2013/07/28/plasma-desktopxS9837.png

So, this is how it's supposed to work - and works fine here. If you can reliably reproduce it not doing that, please post steps.
Comment 16 Eike Hein 2013-07-27 22:43:03 UTC
Side note: An alternative I'm still considering is putting the launchers in their own container on the left and always dividing them evenly across the number of rows, so e.g. in the second screenshot, there would be an area on the left with three launchers in the first row and two launchers on the second row, and the non-launcher task rows would then all align to the same column pushing up against the right edge of the longest launcher row. I think that might be nicer indeed, but it requires significantly more complex code (either two containers negotiating sizes with each other, or a complex sort proxy model), and the current behavior is at least better than the old applet.
Comment 17 Thomas Pfeiffer 2013-07-28 13:43:12 UTC
That looks ways better now!
One thing: The launchers look quite a bit smaller than with the old Plasmoid and thus might be a bit hard to click and looks a bit odd (the latter may just be because I'm not used to it, though)
Comment 18 Eike Hein 2013-07-28 15:01:40 UTC
Thomas,

yeah ... icon sizes are generally a bit smaller in the new applet, because it actually respects the width of the theme's frame margins (i.e. the icon doesn't overlay a part of the button that is technically part of the frame, but is scaled to fit inside the frame elements). Unfortunately that means on very small panels, they do come out quite small since an extra 2-4 pixels is a lot then. I'm still considering tweaking this, either by returning to the (technically incorrect, but then theme authors are used to it now ...) old behavior generally, or special-casing it for smaller panels, not sure yet.

If any of you want to experiment, just have a look at the icon stuff in Task.qml. You can start the applet with "plasma-windowed tasks" after you edit it and will see your changes in a window. If you come up with nice values that work well with a lot of themes and sizes that would be valuable feedback.
Comment 19 Pascal d'Hermilly 2013-07-29 12:05:00 UTC
If the launcher icons are small (because of the frame) it will be inconsistent with the ordinary icons and system tray icons.
Having ordinary icons left of the taskbar followed by launchers will look something like "OOOooo" in size.
It is the same frame that cuts the taskbar entries text in bug 314879 with slim panels.
Also: In my opinion it gives a nicer look when the icons are full size, especially on slim panels.
Comment 20 Eike Hein 2013-07-29 12:08:12 UTC
Re bug 314879, that shouldn't be an issue anymore hopefully ... also, I've done a whole bunch of tweaks today that improve things for very small panels (or very small multi-row configurations).
Comment 21 Thomas Pfeiffer 2013-07-29 12:22:24 UTC
Eike,
thanks for your explanation.
Since I'm not a developer, I am not able to tinker with the QML myself (I'm planning to learn QML, but I'm not there yet).

If the borders only affect the size of the icon but not the size of the launcher's click area, the usability problem is smaller. What remains are harder to recognize icons, but since users have put the launchers into the panel themselves, this would only become a problem for users with many similar-looking launchers in their panel.

I still think that the launcher icon size in the old Plasmoid looked better, but I'm not an expert on that.
Comment 22 Eike Hein 2013-07-30 19:07:06 UTC
Git commit 057bf5de820526d5e4e5cbc2b65c15ce60d96860 by Eike Hein.
Committed on 30/07/2013 at 19:05.
Pushed by hein into branch 'KDE/4.11'.

Cap to preferred max width when distributing the launcher delta.

M  +3    -2    plasma/desktop/applets/tasks/package/contents/code/layout.js

http://commits.kde.org/kde-workspace/057bf5de820526d5e4e5cbc2b65c15ce60d96860
Comment 23 Eike Hein 2013-07-30 19:07:44 UTC
Hrvoje, the above commit fixes what you saw :).
Comment 24 Hrvoje Senjan 2013-07-30 19:51:31 UTC
(In reply to comment #23)
> Hrvoje, the above commit fixes what you saw :).

Very good :-)
Thanks a lot for your work on the (now much improved) new tasks widget! It is indeed much better experience than the old one
Comment 25 stakanov.s 2013-11-28 23:07:47 UTC
this seems to have a regression in 4.11.2.  (if this is not another bug). 
Description: 
the widgeds expand inside the bar. If you click on them the right icon that is hidden (e.g. application launcher) gets visible. But then stays on the desktop as "ghost", the same for other plasmoids like yawp. This also leaves a covering ghost picture and expands inside the pannel. The "ghost" covers everything, also when you open a browser window. I haven't jet managed to make it vanish. 
I join a few screen-shots that describe the problem. This bug was mentioned in bugzilla.novell and declared upstream. 
https://bugzilla.novell.com/show_bug.cgi?id=852555
There I thought it is only a question of yawp. Instead it is an overall problem.
Comment 26 stakanov.s 2013-11-28 23:09:56 UTC
Created attachment 83816 [details]
wrongly expanding plasmoids in bar 4.11.2
Comment 27 stakanov.s 2013-11-28 23:13:08 UTC
Created attachment 83817 [details]
Detail of ghost pictures remaining "burned" on the screen. 4.11.2

These gost pictures are always there, also with yawp. It expands in the bar, but then you find the "small version" of it, just there on the desktop. And goes away only after logout-login.